# kdecore Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KRandomSequence Class Reference

A class to create a pseudo-random sequence. More...

`#include <krandomsequence.h>`

List of all members.

## Public Member Functions

| KRandomSequence (long lngSeed=0)
virtual | ~KRandomSequence ()
| KRandomSequence (const KRandomSequence &a)
KRandomSequence & | operator= (const KRandomSequence &a)
void | setSeed (long lngSeed=1)
double | getDouble ()
unsigned long | getLong (unsigned long max)
bool | getBool ()
void | randomize (QGList *list)
void | modulate (int i)

## Detailed Description

A class to create a pseudo-random sequence.

Given a seed number, this class will produce a sequence of pseudo-random numbers. This would typically be used in applications like games.

In general, you should instantiate a KRandomSequence object and pass along your seed number in the constructor. From then on, simply call getDouble or getLong to obtain the next number in the sequence.

Author:
  Sean Harmer <sh@astro.keele.ac.uk>

Definition at line 39 of file krandomsequence.h.

## Constructor & Destructor Documentation

KRandomSequence::KRandomSequence | ( | long | lngSeed = `0` | ) |

Creates a pseudo-random sequence based on the seed lngSeed.

A Pseudo-random sequence is different for each seed but can be reproduced by starting the sequence with the same seed.

If you need a single value which needs to be unpredictable, you need to use kapp->random() instead.

Parameters:

  | lngSeed | Seed to initialize the sequence with. If lngSeed is 0, the sequence is initialized with a value from KApplication::random().

Definition at line 32 of file krandomsequence.cpp.

References setSeed().

KRandomSequence::~KRandomSequence | ( |  | ) | `[virtual]`

| Standard destructor. Definition at line 42 of file krandomsequence.cpp.

KRandomSequence::KRandomSequence | ( | const KRandomSequence & | a | ) |

| Copy constructor. Definition at line 47 of file krandomsequence.cpp.

## Member Function Documentation

KRandomSequence & KRandomSequence::operator= | ( | const KRandomSequence & | a | ) |

| Assignment. Definition at line 55 of file krandomsequence.cpp. References m_lngSeed1, m_lngSeed2, and m_lngShufflePos.

void KRandomSequence::setSeed | ( | long | lngSeed = `1` | ) |

Restart the sequence based on lngSeed.

Parameters:

  | lngSeed | Seed to initialize the sequence with. If lngSeed is 0, the sequence is initialized with a value from KApplication::random().

Definition at line 69 of file krandomsequence.cpp.

References KApplication::random().

Referenced by KRandomSequence().

double KRandomSequence::getDouble | ( |  | ) |

Get the next number from the pseudo-random sequence.

Returns:
  a pseudo-random double value between [0,1[

Definition at line 185 of file krandomsequence.cpp.

unsigned long KRandomSequence::getLong | ( | unsigned long | max | ) |

Get the next number from the pseudo-random sequence.

Returns:
  a pseudo-random integer value between [0, max[ with 0 <= max < 1.000.000

Definition at line 205 of file krandomsequence.cpp.

Referenced by randomize().

bool KRandomSequence::getBool | ( |  | ) |

Get a boolean from the pseudo-random sequence.

Returns:
  a boolean which is either true or false

Definition at line 213 of file krandomsequence.cpp.

void KRandomSequence::randomize | ( | QGList * | list | ) |

Put a list in random order.

Parameters:

  | list | the list whose order will be modified

Definition at line 229 of file krandomsequence.cpp.

References getLong().

void KRandomSequence::modulate | ( | int | i | ) |

Modulate the random sequence.

If S(i) is the sequence of numbers that will follow given the current state after calling modulate(i), then S(i) != S(j) for i != j and S(i) == S(j) for i == j.

This can be useful in game situation where "undo" restores the state of the random sequence. If the game modulates the random sequence with the move chosen by the player, the random sequence will be identical whenever the player "redo"-s his or hers original move, but different when the player chooses another move.

With this scenario "undo" can no longer be used to repeat a certain move over and over again until the computer reacts with a favorable response or to predict the response for a certain move based on the response to another move.

Parameters:

  | i | the sequence identified

Definition at line 168 of file krandomsequence.cpp.

The documentation for this class was generated from the following files:

- krandomsequence.h
- krandomsequence.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:18:57 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003